#ifndef HCMS_H_
#define HCMS_H_

//#include <avr/io.h>
//#include <stdint.h>

#define		CHIP_CNT		1								//   
#define		CHIP_POS		8								//    1 
#define 	FONT_COLS		5								//     (  )
#define		SCR_SIZE		(CHIP_CNT*CHIP_POS)				//  ,   
#define		CHIP_RAW_SIZE	(CHIP_CNT*CHIP_POS*FONT_COLS)	//     

//    
typedef enum{				// real pwm
	PWM_BRIGHT_000	= 0,	// 0.0%
	PWM_BRIGHT_002	= 1,	// 1.7%
	PWM_BRIGHT_003	= 2, 	// 2.2%
	PWM_BRIGHT_005	= 3, 	// 5.0%
	PWM_BRIGHT_007	= 4, 	// 6.7%
	PWM_BRIGHT_008	= 5, 	// 8.3%
	PWM_BRIGHT_012	= 6, 	// 11.7%
	PWM_BRIGHT_015	= 7, 	// 15%
	PWM_BRIGHT_018	= 8, 	// 18%
	PWM_BRIGHT_023	= 9, 	// 23%
	PWM_BRIGHT_030	= 10,	// 30%
	PWM_BRIGHT_037	= 11,	// 37%
	PWM_BRIGHT_047	= 12,	// 47%
	PWM_BRIGHT_060	= 13,	// 60%
	PWM_BRIGHT_080	= 14,	// 80%
	PWM_PRIGHT_100	= 15 	// 100%
} pwm_brightness_t;

#define MIN_BRIGHTNESS		PWM_BRIGHT_002					//   
#define MAX_BRIGHTNESS		PWM_PRIGHT_100					//   
#define DEFAULT_BRIGHTNESS	PWM_BRIGHT_047					//   

//     
typedef enum{												// real peak current
	PEAK_04_MA		= 2,									//  4.0 mA
	PEAK_06_MA		= 1,									//  6.4 mA
	PEAK_09_MA		= 0,									//  9.3 mA
	PEAK_13_MA		= 3										// 12.8 mA
} peak_current_t;

#define DEFAULT_PEAK_CURRENT	PEAK_09_MA					//    

//  0-  
typedef	union{
	struct{
		pwm_brightness_t
		brightness				: 4;						// 
		peak_current_t
		peak_current			: 2;						//  
		uint8_t	sleep_mode		: 1;						//  
		uint8_t reg				: 1;						//   (  0)
	};
	uint8_t		byte;										//   ,  1 
} ctrl_reg0_t;

//  1-  
typedef	union{
	struct{
		uint8_t	data_out_ctrl	: 1;						//     DOUT
		uint8_t	edo_prescaler	: 1;						//    
		uint8_t	reserved		: 5;						//   !
		uint8_t	reg				: 1;						//   (  1)
	};
	uint8_t		byte;										//   ,  1 
} ctrl_reg1_t;

extern char hcms_screen[SCR_SIZE];							//   

///  
void hcms_clrscr(void);

/**    
 *     ,    .  
 * ,     .
 * @param s  
 */
void hcms_puts(char *s);

/**    flash  
 * ,    , ,   ,
 *      
 * @param s   flash
 */
void hcms_puts_P(const char *s);

/**  
 *      
 */
void hcms_update_scr(void);

/**   
 *
 * @param br  
 */
void hcms_bright(pwm_brightness_t br);

/**    
 *
 * @param pc   
 */
void hcms_peak_current(peak_current_t pc);

/** / 
 *       sleep.
 * @param on  - ,   -  
 */
void hcms_on(uint8_t on);

/**  
 *    
 */
void hcms_init(void);

//    
/**    
 *      .
 * @param buf   
 * @param sz   
 */
void hcms_raw_pixels(uint8_t *buf, uint16_t sz);

unsigned int get_offset_char(char c);

#endif /* HCMS_H_ */