﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Configurator
{
    public partial class Form_Main : Form
    {
        // Переменная хранения имен входов и выходов
        String in_out_names = "";

        public Form_Main()
        {
            InitializeComponent();            
        }     

        private void Form1_Load(object sender, EventArgs e)
        {
            // Обновить пределы изменения количества входов и выходов в соответствии с Relay Modules Counts
            this.numeric_in_counts.Maximum = this.numeric_rel_counts.Value * 8 - 1;
            this.numeric_out_counts.Maximum = this.numeric_rel_counts.Value * 8 - 1;

            // Обновить количество входов и выходов в соответствии с Relay Modules Counts
            this.numeric_in_counts.Value = this.numeric_rel_counts.Value * 8 / 2;
            this.numeric_out_counts.Value = this.numeric_rel_counts.Value * 8 - this.numeric_in_counts.Value;

            this.numeric_rel_counts.ValueChanged += new System.EventHandler(Numeric_rel_counts_ValueChanged);
            this.numeric_in_counts.ValueChanged += new System.EventHandler(Numeric_in_counts_ValueChanged);
            this.numeric_out_counts.ValueChanged += new System.EventHandler(Numeric_out_counts_ValueChanged);
        }

        // Обновить список имен входов/выходов
        private void Update_List_InOut_Names()
        {
            for (int i = 1; i <= 31; i++)
            {
                foreach (Control l in group_names.Controls)
                {
                    if (l.Name == "label_in" + i.ToString())
                    {
                        if (i <= this.numeric_in_counts.Value) l.Enabled = true;
                        else l.Enabled = false;
                    }

                    if (l.Name == "textBox_in" + i.ToString())
                    {
                        if (i <= this.numeric_in_counts.Value) l.Enabled = true;
                        else l.Enabled = false;
                    }

                    if (l.Name == "label_out" + i.ToString())
                    {
                        if (i <= this.numeric_out_counts.Value) l.Enabled = true;
                        else l.Enabled = false;
                    }

                    if (l.Name == "textBox_out" + i.ToString())
                    {
                        if (i <= this.numeric_out_counts.Value) l.Enabled = true;
                        else l.Enabled = false;
                    }
                }
            }
        }

        private void Numeric_rel_counts_ValueChanged(Object sender, EventArgs e)
        {
            this.numeric_in_counts.Maximum = this.numeric_rel_counts.Value * 8 - 1;
            this.numeric_out_counts.Maximum = this.numeric_rel_counts.Value * 8 - 1;
            this.numeric_in_counts.Value = this.numeric_rel_counts.Value * 8 / 2;
            this.numeric_out_counts.Value = this.numeric_rel_counts.Value * 8 - this.numeric_in_counts.Value;
            Update_List_InOut_Names();
        }

        private void Numeric_in_counts_ValueChanged(object sender, EventArgs e)
        {
            this.numeric_out_counts.Value = this.numeric_rel_counts.Value * 8 - this.numeric_in_counts.Value;
            Update_List_InOut_Names();
        }

        private void Numeric_out_counts_ValueChanged(object sender, EventArgs e)
        {
            this.numeric_in_counts.Value = this.numeric_rel_counts.Value * 8 - this.numeric_out_counts.Value;
            Update_List_InOut_Names();
        }

        private void Button_defaults_Click(object sender, EventArgs e)
        {
            // Сбросить все значения на значения по умолчанию
            var result = MessageBox.Show("Reset to defaults values? This operation is irreversible.", "Reset",
                                 MessageBoxButtons.YesNo,
                                 MessageBoxIcon.Question);
            
            if (result == DialogResult.Yes)
            {
                this.numeric_out_counts.Value = 4;
                this.numeric_in_counts.Value = 4;
                this.numeric_rel_counts.Value = 1;

                this.textBox_out30.Text = "30";
                this.textBox_out29.Text = "29";
                this.textBox_out28.Text = "28";
                this.textBox_out27.Text = "27";
                this.textBox_out26.Text = "26";
                this.textBox_out25.Text = "25";
                this.textBox_out24.Text = "24";
                this.textBox_out23.Text = "23";
                this.textBox_out22.Text = "22";
                this.textBox_out21.Text = "21";
                this.textBox_out20.Text = "20";
                this.textBox_out19.Text = "19";
                this.textBox_out18.Text = "18";
                this.textBox_out17.Text = "17";
                this.textBox_out16.Text = "16";
                this.textBox_out15.Text = "15";
                this.textBox_out14.Text = "14";
                this.textBox_out13.Text = "13";
                this.textBox_out12.Text = "12";
                this.textBox_out11.Text = "11";
                this.textBox_out10.Text = "10";
                this.textBox_out9.Text  = "09";
                this.textBox_out8.Text  = "08";
                this.textBox_out7.Text  = "07";
                this.textBox_out6.Text  = "06";
                this.textBox_out5.Text  = "05";
                this.textBox_out4.Text  = "04";
                this.textBox_out3.Text  = "03";
                this.textBox_out2.Text  = "02";
                this.textBox_out1.Text  = "01";

                this.textBox_in31.Text = "31";
                this.textBox_in30.Text = "30";
                this.textBox_in29.Text = "29";
                this.textBox_in28.Text = "28";
                this.textBox_in27.Text = "27";
                this.textBox_in26.Text = "26";
                this.textBox_in25.Text = "25";
                this.textBox_in24.Text = "24";
                this.textBox_in23.Text = "23";
                this.textBox_in22.Text = "22";
                this.textBox_in21.Text = "21";
                this.textBox_in20.Text = "20";
                this.textBox_in19.Text = "19";
                this.textBox_in18.Text = "18";
                this.textBox_in17.Text = "17";
                this.textBox_in16.Text = "16";
                this.textBox_in15.Text = "15";
                this.textBox_in14.Text = "14";
                this.textBox_in13.Text = "13";
                this.textBox_in12.Text = "12";
                this.textBox_in11.Text = "11";
                this.textBox_in10.Text = "10";
                this.textBox_in9.Text  = "09";
                this.textBox_in8.Text  = "08";
                this.textBox_in7.Text  = "07";
                this.textBox_in6.Text  = "06";
                this.textBox_in5.Text  = "05";
                this.textBox_in4.Text  = "04";
                this.textBox_in3.Text  = "03";
                this.textBox_in2.Text  = "02";
                this.textBox_in1.Text  = "01";

                this.radio_256.Checked = true;
                this.radio_512.Checked = false;
            }
        }

        private String Extract_names()
        {
            String inputs_names = "", outputs_names = "";

            // Извлечь имена входов из TextBox

            for (int i = 0; i < 32; i++)
            {
                foreach (Control l in group_names.Controls)
                {
                    if (l.Name == "textBox_in" + i.ToString())
                    {
                        // Если имя пустое, сделать стандартным
                        if ((l.Text == "") | (l.Text == " ") | (l.Text == "  ") | (l.Text == "   "))
                        {
                            l.Text = i.ToString("00");
                        }

                        for (int j = l.Text.Length; j < 3; j++)     // Дополнить символами пробела, если имя короче трех сиволов
                        {
                            inputs_names += " ";
                        }

                        inputs_names += l.Text;                     // Добавить к строке имя из TextBox
                    }
                }
            }

            // Извлечь имена выходов из TextBox

            for (int i = 0; i < 32; i++)
            {
                foreach (Control l in group_names.Controls)
                {
                    if (l.Name == "textBox_out" + i.ToString())
                    {
                        // Если имя пустое, сделать стандартным
                        if ((l.Text == "") | (l.Text == " ") | (l.Text == "  ") | (l.Text == "   "))
                        {
                            l.Text = i.ToString("00");
                        }

                        outputs_names += l.Text;                    // Добавить к строке имя из TextBox

                        for (int j = l.Text.Length; j < 3; j++)     // Дополнить символами пробела, если оно короче трех сиволов
                        {
                            outputs_names += " ";
                        }
                    }
                }
            }
            
            // Преобразовать строку входов в HEX
            
            for (int i = 0; i < inputs_names.Length; i++)
            {
                in_out_names += System.Convert.ToByte(inputs_names[i]).ToString("X2");
            }

            // Преобразовать строку выходов в HEX
            
            for (int i = 0; i < outputs_names.Length; i++)
            {
                in_out_names += System.Convert.ToByte(outputs_names[i]).ToString("X2");
            }

            return in_out_names += "FFFFFFFFFFFF";  // Дополнить строку, чтобы была кратна 32 и вернуть
        }

        private String Get_checksum(String s)
        {
            /* For example, in the case of the record :0300300002337A1E, 
             * the sum of the decoded byte values is 03 + 00 + 30 + 00 + 02 + 33 + 7A = E2.
             * The two's complement of E2 is 1E, which is the checksum byte appearing at the end of the record.
             * */

            int sum = 0;

            for (int i = 0; i < s.Length; i += 2)
            {
                sum += Int32.Parse(s.Substring(i, 2), System.Globalization.NumberStyles.HexNumber);
            }

            return ((~sum + 1) & 0xFF).ToString("X2");
        }

        private void Button_save_Click(object sender, EventArgs e)
        {
            in_out_names = "";

            SaveFileDialog savefile = new SaveFileDialog
            {
                DefaultExt = ".eep",
                Filter = "EEPROM files|*.eep",
                InitialDirectory = Application.StartupPath
            };
            
            if (this.radio_256.Checked)
            {
                savefile.FileName = "EEPROM_Data_256";
            }
            else
            {
                savefile.FileName = "EEPROM_Data_512";
            }

            if (savefile.ShowDialog() == System.Windows.Forms.DialogResult.OK && savefile.FileName.Length > 0)
            {
                using (StreamWriter sw = new StreamWriter(savefile.FileName, false))
                {
                    in_out_names = Extract_names();    // Извлечь все имена из TextBox и преобразовать в HEX

                    // Первая строка - хранение различных настроек
                    String  active_input    = "00",
                            active_output   = "00",
                            lock_state      = "00",
                            mute_state      = "01",
                            brightness      = "11",
                            in_out_order    = "01";
                                        
                    String  temp = "";

                    temp = ":10" + "0000" + "00" 
                        + System.Convert.ToByte(active_input).ToString("X2") 
                        + System.Convert.ToByte(active_output).ToString("X2") 
                        + System.Convert.ToByte(lock_state).ToString("X2")
                        + System.Convert.ToByte(mute_state).ToString("X2")
                        + System.Convert.ToByte(numeric_rel_counts.Value).ToString("X2")
                        + System.Convert.ToByte(numeric_in_counts.Value).ToString("X2") 
                        + System.Convert.ToByte(brightness).ToString("X2")
                        + System.Convert.ToByte(in_out_order).ToString("X2")
                        + "FFFFFFFFFFFFFFFF";

                    sw.WriteLine(temp + Get_checksum(temp.Substring(1)));

                    // Вторая и последующие строки - хранение имен

                    int i = 0, addr = 1;

                    while (i < in_out_names.Length)
                    {
                        temp = ":1000" + System.Convert.ToByte(addr).ToString("X") + "0" + "00";
                        temp += in_out_names.Substring(i, 32);
                        temp += Get_checksum(temp.Substring(1));
                        sw.WriteLine(temp);
                     i += 32;
                        addr++;
                    }

                    // Добавить недостающие строки
                    sw.WriteLine(":1000D000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF30");
                    sw.WriteLine(":1000E000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF20");
                    sw.WriteLine(":1000F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF10");

                    // Если объем EEPROM 512 байт, то добавить еще строки
                    if (this.radio_512.Checked)
                    {
                        sw.WriteLine(":10010000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF");
                        sw.WriteLine(":10011000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF");
                        sw.WriteLine(":10012000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF");
                        sw.WriteLine(":10013000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF");
                        sw.WriteLine(":10014000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF");
                        sw.WriteLine(":10015000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF");
                        sw.WriteLine(":10016000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F");
                        sw.WriteLine(":10017000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F");
                        sw.WriteLine(":10018000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F");
                        sw.WriteLine(":10019000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F");
                        sw.WriteLine(":1001A000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F");
                        sw.WriteLine(":1001B000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F");
                        sw.WriteLine(":1001C000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F");
                        sw.WriteLine(":1001D000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2F");
                        sw.WriteLine(":1001E000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1F");
                        sw.WriteLine(":1001F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F");
                    }

                    // Последняя строка - конец файла
                    sw.WriteLine(":00000001FF");       // EOF

                    sw.Close();
                    MessageBox.Show("File saved sucsessful!", "Message");
                }
            }
        }

        private void Button_info_Click(object sender, EventArgs e)
        {
            Form_Info f = new Form_Info();
            f.Hide();
            f.Show();
        }

        private void Picture_display_Click(object sender, EventArgs e)
        {

        }
    }
}

/*  Структура типового файла EEPROM
    :10000000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF00
    :10001000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0
    :10002000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFE0
    :10003000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFD0
    :10004000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFC0
    :10005000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFB0
    :10006000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFA0
    :10007000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF90
    :10008000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF80
    :10009000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF70
    :1000A000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF60
    :1000B000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF50
    :1000C000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF40
    :1000D000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF30
    :1000E000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF20
    :1000F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF10     -- у ATtiny44 файл заканчивается здесь, ниже для ATtiny840010000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
    :10010000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF
    :10011000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFEF
    :10012000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFDF
    :10013000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFCF
    :10014000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFBF
    :10015000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFAF
    :10016000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF9F
    :10017000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF8F
    :10018000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF7F
    :10019000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF6F
    :1001A000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF5F
    :1001B000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF4F
    :1001C000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF3F
    :1001D000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF2F
    :1001E000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF1F
    :1001F000FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF0F
    :00000001FF
*/
